/**
 * ComponentDecorators.ts
 * Copyright: Microsoft 2019
 *
 * Exposes helper decorator functions for use with ReSub Components
 */
import * as _ from './lodashMini';
export function CustomEqualityShouldComponentUpdate(comparator) {
    return function (constructor) {
        constructor.prototype.shouldComponentUpdate = comparator;
        return constructor;
    };
}
export function DeepEqualityShouldComponentUpdate(constructor) {
    return CustomEqualityShouldComponentUpdate(deepEqualityComparator)(constructor);
}
function deepEqualityComparator(nextProps, nextState, nextContext) {
    return !_.isEqual(this.state, nextState) ||
        !_.isEqual(this.props, nextProps) ||
        !_.isEqual(this.context, nextContext);
}
