"use strict";
/**
 * ComponentDecorators.ts
 * Copyright: Microsoft 2019
 *
 * Exposes helper decorator functions for use with ReSub Components
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("./lodashMini"));
function CustomEqualityShouldComponentUpdate(comparator) {
    return function (constructor) {
        constructor.prototype.shouldComponentUpdate = comparator;
        return constructor;
    };
}
exports.CustomEqualityShouldComponentUpdate = CustomEqualityShouldComponentUpdate;
function DeepEqualityShouldComponentUpdate(constructor) {
    return CustomEqualityShouldComponentUpdate(deepEqualityComparator)(constructor);
}
exports.DeepEqualityShouldComponentUpdate = DeepEqualityShouldComponentUpdate;
function deepEqualityComparator(nextProps, nextState, nextContext) {
    return !_.isEqual(this.state, nextState) ||
        !_.isEqual(this.props, nextProps) ||
        !_.isEqual(this.context, nextContext);
}
